local leadWire = ...

--------------------------------------------------------------------------
local LEAD_WIRE_COMP = {
	TypeName = _PrefixAsset .. "LEAD_WIRE_COMP",
	ParentType = "COMPONENT",
	Properties = {
                { Name = "LeadWire_IsSet", Type = "boolean", Default = false },
 	}
}

--------------------------------------------------------------------------
function LEAD_WIRE_COMP:create()
                self._monumentObject = nil
end

--------------------------------------------------------------------------
function LEAD_WIRE_COMP:init()
    self.LeadWire_IsSet = true
    leadWire:log("LeadWire_IsSet = " .. tostring(self.LeadWire_IsSet) .. " y = " .. self:getOwner():getGlobalPosition()[2])
    self:setChildsElevation()
end

function LEAD_WIRE_COMP:onFinalize(_isClearingLevel)
    self.LeadWire_IsSet = false
    leadWire:log("restore on spirit level destroy ")
    if self._monumentObject == nil then
        leadWire:log("monumentObject nil " .. tostring(self._monumentObject))
        return
    end    
    leadWire:log("call forEachChildRecursive on spirit level destroy " .. tostring(self._monumentObject))
    self._monumentObject:forEachChildRecursive(function(_decoration)
        if _decoration == nil then
            leadWire:log("_decoration == nil")
            return
        end
        leadWire:log("call restorePosition " .. tostring(_decoration))
        _decoration:getComponent(_PrefixAsset .. "LEAD_WIRE_ALIGN_COMP"):restorePosition()
        end)
    self._monumentObject = nil
    leadWire:log("end restore on spirit level destroy ")
end

function setChildElevation(_decoration)
   leadWire:log("setChildElevation begin")
   if _decoration == nil then
       leadWire:log("_decoration nil")
       return
   end
   if _decoration:getComponent(_PrefixAsset .. "LEAD_WIRE_ALIGN_COMP") == nil then
       leadWire:log("Component nil")
       return
   end
   if _decoration:getComponent(_PrefixAsset .. "LEAD_WIRE_ALIGN_COMP").init == nil then
       leadWire:log("init not defined")
       return
   end
   _decoration:getComponent(_PrefixAsset .. "LEAD_WIRE_ALIGN_COMP"):init()
   leadWire:log("setChildElevation end")
end

function LEAD_WIRE_COMP:setChildsElevation()
        leadWire:log("setChildsElevation begin")
        local _currentObject = self:getOwner() 
        for i=0,20, 1 do
            local _parent = _currentObject:getParent()
            if _parent == nil then    
                leadWire:log("parent nil")
                return
            end
            if _parent.Name == _PrefixAsset .. "MONUMENT_NAME" then    
                leadWire:log("call forEachChildRecursive")
                _parent:forEachChildRecursive(setChildElevation)
                self._monumentObject = _parent
                break
            end
            _currentObject = _parent
        end
        leadWire:log("setChildsElevation end")
end

-------------------------------------
function LEAD_WIRE_COMP:update()
end

--------------------------------------------------------------------------
leadWire:registerClass(LEAD_WIRE_COMP)
